<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX User Guide: TIOVX Build Instructions</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">


<h1><a class="anchor" id="BUILD_INSTRUCTIONS">TIOVX Build Instructions </a></h1><dl class="user"><dt><b>Contents</b></dt><dd><ul>
<li><a class="el" href="BUILD_INSTRUCTIONS.html#BUILD_VSDK">Build instructions for Vision SDK Platform</a></li>
<li><a class="el" href="BUILD_INSTRUCTIONS.html#BUILD_LINUX">Build instructions for x86 Linux Platform (HOST Emulation Mode)</a></li>
<li><a class="el" href="BUILD_INSTRUCTIONS.html#BUILD_OPTIONS">Makefile build options</a></li>
<li><a class="el" href="BUILD_INSTRUCTIONS.html#BUILD_CLEAN">Deleting all generated files</a></li>
</ul>
</dd></dl>
<p><br/>
<hr/>
<h2><a class="anchor" id="BUILD_VSDK">
Build instructions for Vision SDK Platform</a></h2>
<dl class="user"><dt><b>Requirements</b></dt><dd><ul>
<li>Install Vision SDK vXX.XX.XX.XX as mentioned in the TIOVX release notes<ul>
<li>This will install all packages needed to build Vision SDK</li>
<li>This will also install TIOVX, VXLIB and other OpenVX related packages</li>
</ul>
</li>
</ul>
</dd></dl>
<dl class="user"><dt><b>Setup</b></dt><dd><ul>
<li>Edit $TIOVX_PATH/tools_path.mk, modify paths for various dependant packages if required.<ul>
<li>NOTE: When Vision SDK is installed, all paths in this file would be setup to point to correct locations within the Vision SDK installation.</li>
</ul>
</li>
<li>For windows build environment,<ul>
<li>Make sure "xdctools_x_xx_xx_xx_core/bin/gmake" available as part of XDC package (included in Vision SDK) is visible in the system path.</li>
</ul>
</li>
<li>Edit $TIOVX_PATH/Makefile<ul>
<li>set BUILD_EMULATION_MODE=no and BUILD_TARGET_MODE=yes</li>
</ul>
</li>
</ul>
</dd></dl>
<dl class="user"><dt><b>Build</b></dt><dd><ul>
<li>Open a command prompt at $TIOVX_PATH</li>
<li>Type "make" (on Linux) or "gmake" (on Windows) to build TIOVX and associated libraries<ul>
<li>This builds the TIOVX libaries</li>
<li>Conformance test and tutorial is built as a library</li>
</ul>
</li>
<li>The final Vision SDK executable with the OpenVX conformance test, tutorial needs to be build from Vision SDK folder</li>
<li>Steps to build Vision SDK, (OpenVX is enabled by default in Vision SDK)<ul>
<li>In vision_sdk/build/Rules.make<ul>
<li>set MAKECONFIG to one of below based on yor SoC/EVM<ul>
<li>set MAKECONFIG=tda2xx_evm_bios_all # For TDA2x BIOS ONLY</li>
<li>set MAKECONFIG=tda2ex_evm_bios_all # For TDA2Ex BIOS ONLY</li>
<li>set MAKECONFIG=tda3xx_evm_bios_all # For TDA3x BIOS ONLY</li>
<li>set MAKECONFIG=tda2xx_evm_linux_all # For TDA2x Linux+BIOS</li>
<li>set MAKECONFIG=tda2ex_evm_linux_all # For TDA2Ex Linux+BIOS</li>
</ul>
</li>
<li>set PROFILE to one of below<ul>
<li>debug</li>
<li>release [default]</li>
</ul>
</li>
</ul>
</li>
<li>Build Vision SDK and bootloader by following steps in appropiate SoC/EVM User Guide in Vision SDK<ul>
<li>Typical Vision SDK build steps are (refer user guide for details) <div class="fragment"><pre class="fragment">        make linux         # <span class="keywordflow">for</span> LINUX+BIOS config, build linux kernel, uboot, kernel modules
        make linux_install # <span class="keywordflow">for</span> LINUX+BIOS config, install kernel modules <a class="code" href="tiovx__performance__TDA2Ex__BIOS_8html.html#abbc43ef69f541dca5e2ca497cfdaeb9f">to</a> linux filesystem
        make -s -j depend  # build drivers and other dependancies
        make -s -j         # build Vision SDK application binary
        make -s sbl        # <span class="keywordflow">for</span> BIOS config only, build SBL (secondary bootloader)
        make -s appimage   # <span class="keywordflow">for</span> BIOS config only, make SBL bootable application binary
</pre></div></li>
</ul>
</li>
<li>When Vision SDK is built, it will link against the tiovx related libraries</li>
</ul>
</li>
</ul>
</dd></dl>
<dl class="user"><dt><b>Running the conformance test and tutorial (for BIOS ONLY config)</b></dt><dd><ul>
<li>Flash/copy the Vision SDK bootloader, "AppImage" and setup the EVM as mentioned in SoC/EVM User Guide in Vision SDK</li>
<li>Copy the test data used in conformance test to an SD card<ul>
<li>Copy all files and folders from "$TIOVX_PATH\conformance_tests\test_data" to "test_data" folder in SD card</li>
</ul>
</li>
<li>Boot the EVM, with the SD card inserted and use the menu in UART terminal to navigate to the OpenVX use-cases and run the conformance test, tutorial</li>
<li>NOTE: Output .bmp files generated by the tutorial will be present in SD card in the folder "test_data"</li>
</ul>
</dd></dl>
<dl class="user"><dt><b>Running the Camera+Display with OpenVX use-case (for BIOS ONLY config)</b></dt><dd><ul>
<li>Flash/copy the Vision SDK bootloader, "AppImage" and setup the EVM as mentioned in SoC/EVM User Guide in Vision SDK</li>
<li>Connect a OV10635 sensor to the EVM as mentioned in SoC/EVM User Guide in Vision SDK</li>
<li>Connect a HDMI Display to the EVM as mentioned in SoC/EVM User Guide in Vision SDK</li>
<li>Boot the EVM, with the SD card inserted and use the menu in UART terminal to navigate to the OpenVX use-cases and run the "VIP Single Channel Capture + OpenVX + Display" option</li>
</ul>
</dd></dl>
<dl class="user"><dt><b>Running the conformance test and tutorial (for LINUX+BIOS config)</b></dt><dd><ul>
<li>Copy all files and folders from "$TIOVX_PATH\conformance_tests\test_data" to Linux filesystem at "/opt/openvx/test_data"</li>
<li>Do the below steps as mentioned in Vision SDK user guide<ul>
<li>Flash the linux kernel, uboot, filesystem to SD card</li>
<li>Boot the EVM</li>
<li>At the linux command prompt set path of test data as shown below<ul>
<li>export VX_TEST_DATA_PATH=/opt/openvx/test_data</li>
</ul>
</li>
<li>Run the Vision SDK demo application</li>
</ul>
</li>
<li>Use the menu in UART terminal to navigate to the OpenVX use-cases and run the conformance test, tutorial</li>
<li>NOTE: Output .bmp files generated by the tutorial will be present in filesystem in the folder $VX_TEST_DATA_PATH</li>
</ul>
</dd></dl>
<p><br/>
<hr/>
<h2><a class="anchor" id="BUILD_LINUX">
Build instructions for x86 Linux Platform (HOST Emulation Mode)</a></h2>
<dl class="user"><dt><b>Requirements</b></dt><dd><ul>
<li>GCC and Linux<ul>
<li>Currently the build is tested with Ubuntu 14.04</li>
<li>Make sure GCC v4.8.4 or higer is installed and visible in your system path</li>
<li>Make sure GNU make is installed and visible in your system path</li>
<li>GCC compiler with 32b mode support is required for using TIOVX<ul>
<li>Make sure below linux packages are installed. This is requiered to use GCC in 32b mode on 64b systems. <div class="fragment"><pre class="fragment">        sudo apt-<span class="keyword">get</span> install g++-multilib libc6 libc6-dev
</pre></div></li>
</ul>
</li>
</ul>
</li>
</ul>
</dd></dl>
<dl class="user"><dt><b>Setup</b></dt><dd><ul>
<li>Edit $TIOVX_PATH/tools_path.mk<ul>
<li>Modify "GCC_LINUX_ROOT := /usr/" to match your environment if needed</li>
<li>The following paths are the only paths that must be set correctly for host emulation mode. (If paths have been already set for build for Vision SDK Platform, they do not need to be changed.)<ul>
<li>VXLIB_PATH</li>
<li>DMAUTILS_PATH (must only be set if BUILD_BAM option is enabled)</li>
<li>ALGFRAMEWORK_PATH (must only be set if BUILD_BAM option is enabled)</li>
<li>EVE_SW_PATH (must only be set if BUILD_IVISION_KERNELS is enabled)</li>
</ul>
</li>
</ul>
</li>
<li>Edit $TIOVX_PATH/Makefile<ul>
<li>set BUILD_EMULATION_MODE=yes and BUILD_TARGET_MODE=no</li>
</ul>
</li>
</ul>
</dd></dl>
<dl class="user"><dt><b>Build</b></dt><dd><ul>
<li>Open a command prompt at $TIOVX_PATH</li>
<li>Type "make" to build TIOVX and associated libraries<ul>
<li>This builds the TIOVX libaries and conformance test, tutorial executables</li>
<li>This uses pre-built library for VXLIB, DMAUtils, Algframework from "$TIOVX_PATH\lib\PC\X86\LINUX\$PROFILE\*.a"</li>
<li>The pre-built libaries are compiled in 32bit x86 host emulation mode</li>
</ul>
</li>
<li>Conformance test, tutorial executable is output at<ul>
<li>"$TIOVX_PATH\bin\PC\X86\LINUX\debug\vx_conformance_tests_exe"</li>
<li>"$TIOVX_PATH\bin\PC\X86\LINUX\debug\vx_tutorial_exe"</li>
</ul>
</li>
</ul>
</dd></dl>
<dl class="user"><dt><b>Running the conformance test and tutorial</b></dt><dd><ul>
<li>Open a command prompt at the folder "$TIOVX_PATH/bin/PC/X86/LINUX/$PROFILE/"</li>
<li>Set environment variable below to specify the path of the test data. This is used by both the conformance test and tutorial executables <div class="fragment"><pre class="fragment">    export VX_TEST_DATA_PATH=../../../../../conformance_tests/test_data
</pre></div></li>
<li>Execute "./vx_conformance_tests_exe" to run the conformance test</li>
<li>Execute "./vx_tutorial_exe" to run the tutorial</li>
<li>NOTE: Output .bmp files generated by the tutorial will be present in the folder $VX_TEST_DATA_PATH</li>
</ul>
</dd></dl>
<p><br/>
<hr/>
<h2><a class="anchor" id="BUILD_OPTIONS">
Makefile build options</a></h2>
<table frame="box" rules="all" cellspacing="0" width="50%" border="1" cellpadding="3">
<tr bgcolor="lightgrey">
<th><p>Build Option  </p>
</th><th><p>Description  </p>
</th><th><p>Default Setting   </p>
</th></tr>
<tr>
<td><p>BUILD_EMULATION_MODE  </p>
</td><td><p>Builds PC emulation mode  </p>
</td><td><p>no   </p>
</td></tr>
<tr>
<td><p>BUILD_TARGET_MODE  </p>
</td><td><p>Builds for target SoC platform like TDAxx  </p>
</td><td><p>yes   </p>
</td></tr>
<tr>
<td><p>BUILD_CONFORMANCE_TEST  </p>
</td><td><p>Builds entire test suite executable  </p>
</td><td><p>yes   </p>
</td></tr>
<tr>
<td><p>BUILD_IVISION_KERNELS  </p>
</td><td><p>Builds iVision kernels (EVE_SW_PATH required to be set for this build)  </p>
</td><td><p>yes   </p>
</td></tr>
<tr>
<td><p>BUILD_BAM  </p>
</td><td><p>Builds DMA wrapper (DMAUTILS_PATH and ALGFRAMEWORK_PATH required to be set for this build)  </p>
</td><td><p>yes   </p>
</td></tr>
<tr>
<td><p>BUILD_TUTORIAL  </p>
</td><td><p>Builds OpenVX tutorial  </p>
</td><td><p>yes   </p>
</td></tr>
<tr>
<td><p>BUILD_LINUX_A15  </p>
</td><td><p>Builds for A15 Linux target  </p>
</td><td><p>yes   </p>
</td></tr>
</table>
<p><br/>
<hr/>
<h2><a class="anchor" id="BUILD_CLEAN">
Deleting all generated files</a></h2>
<ul>
<li>To do a clean build, do "(g)make clean"</li>
<li>To manually delete generated files do below <div class="fragment"><pre class="fragment">    Delete directory out/
    Delete directory bin/
    Delete directory lib/TDAX/
    Delete files libvx_*.a from lib/PC/X86/$PROFILE
</pre></div> </li>
</ul>
</div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
